<?

function MsCalendarRender( $input, array $args, Parser $parser, PPFrame $frame ) {
	global $wgOut;

	$parser->disableCache();
	//load module
 	$wgOut->addModules( 'ext.MsCalendar' );

	$output = '<div class="custom-header">';
	$output .= '<div id="custom-current" class="custom-current" title="zum heutigen Datum springen">Heute</div>';
	
	$output .= '<span id="custom-next-year" class="custom-next"></span>';
	$output .= '<div class="custom-year-year"><div class="custom-year"></div></div>';
	$output .= '<span id="custom-prev-year" class="custom-prev"></span>';
	
	$output .= '<span id="custom-next" class="custom-next"></span>';
	$output .= '<div class="custom-year-month"><div id="custom-month" class="custom-month"></div></div>';
	$output .= '<span id="custom-prev" class="custom-prev"></span>';
	
	$output .= '</div>';
	$output .= '<div id="calendar" cal_name="'.$args['name'].'" cal_id="" cal_sort="'.$args['sort'].'" class="fc-calendar-container"></div>';
	
	return $output;

}



$wgAjaxExportList[] = 'MsCalGetMonth';
function MsCalGetMonth($month,$year,$cal_id,$cal_sort){

	if($cal_id > 0){
				
		if ($cal_sort == "abc"){
			$sorts = "ORDER BY Text";
		} else {
			$sorts = "ORDER BY ID";
		}
		$vars = array();
		$m_dbObj =& wfGetDB( DB_SLAVE );
		
		 $m_tblCalList = $m_dbObj->tableName( 'mscal_list' );
		 $m_tblCalCont = $m_dbObj->tableName( 'mscal_content' );
			
			
		    $m_sql = "SELECT Date, 
		    	DATE_FORMAT(Date, '%m') as monat, 
		    	YEAR(date) as jahr, 
		    	DAY(date) as tag, 
		    	DATE_FORMAT(Date, '%m-%d-%Y') as Datum, 
		    	Text_ID, b.ID, Text, Duration, Start_Date, Yearly, Day_of_Set 
		    FROM $m_tblCalList a, $m_tblCalCont b 
		    WHERE MONTH(Date) = '".$month."' AND a.Text_ID = b.ID AND a.Cal_ID = '".$cal_id."' ".$sorts."";
		    
		    $m_res = $m_dbObj->query( $m_sql, __METHOD__ ); 
		    while ($m_row = $m_dbObj->fetchRow( $m_res )){
		    						
		    		
		    		if( $m_row['jahr'] == $year)	{
		    			
		    		$vars[$m_row["Datum"]][] = array( 
		    			"ID" => $m_row['Text_ID'],
		    			"Text" => $m_row['Text'],
		    			"Duration" => $m_row['Duration'],
		    			"Day" => $m_row['Day_of_Set'],
		    			"Yearly" => $m_row['Yearly']
					);		    			

		    		} else if($m_row['Yearly'] == 1){
		    				
					$new_date = $m_row['monat']."-".$m_row['tag']."-".$year;		
		    		$vars[$new_date][] = array( 
		    			"ID" => $m_row['Text_ID'],
		    			"Text" => $m_row['Text'],
		    			"Duration" => $m_row['Duration'],
		    			"Day" => $m_row['Day_of_Set'],
		    			"Yearly" => $m_row['Yearly']
					);
		    		}
		    				


		    } //while

	
		$m_dbObj->freeResult( $m_res );   
	}

	return json_encode($vars);
}

$wgAjaxExportList[] = 'MsCalSaveNew';
function MsCalSaveNew($cal_id,$date,$title,$event_id,$duration,$yearly){
		
	$newDate = date("Y-m-d", strtotime($date));	
	$newDate2 = date("m-d-Y", strtotime($date));	
	
	
	 $m_dbObj =& wfGetDB( DB_SLAVE );
   	 $m_tblCalCont = $m_dbObj->tableName( 'mscal_content' );		
	
			    
	 $m_sql = "INSERT INTO $m_tblCalCont (ID, Text, Start_Date, Duration, Yearly) VALUES ('','".$title."','".$newDate."','".$duration."','".$yearly."')";
     $m_res = $m_dbObj->query( $m_sql, __METHOD__ );   		
		

	   $m_sql = "SELECT MAX(ID) as maxid FROM $m_tblCalCont";
       $m_res = $m_dbObj->query( $m_sql, __METHOD__ ); 
       $m_row = $m_dbObj->fetchRow( $m_res ); 
       $maxid =  $m_row['maxid'];	
		
	$m_tblCalList = $m_dbObj->tableName( 'mscal_list' );
	
	
	for($i=0;$i<$duration;$i++){
			
			$addDate = date('Y-m-d', strtotime($newDate. ' + '.$i.' days'));
			$m_sql = "INSERT INTO $m_tblCalList (ID, Date, Text_ID, Day_of_Set, Cal_ID) VALUES ('','".$addDate."','".$maxid."','".($i+1)."','".$cal_id."')";
    		$m_res = $m_dbObj->query( $m_sql, __METHOD__ ); 		
	} //for
	
	$vars[$newDate2][] = array( 
    			"ID" => $maxid,
    			"Text" => $title,
    			"Duration" => $duration,
    			"Yearly" => $yearly
			);
	
	return json_encode($vars);
}

$wgAjaxExportList[] = 'MsCalUpdate';
function MsCalUpdate($cal_id,$date,$title,$event_id,$duration,$yearly){
		
		
	$newDate = date("Y-m-d", strtotime($date));	
	$newDate2 = date("m-d-Y", strtotime($date));	
	
	$m_dbObj =& wfGetDB( DB_SLAVE );
   	$m_tblCalCont = $m_dbObj->tableName( 'mscal_content' );		
	
			    
	$m_sql = "UPDATE $m_tblCalCont SET Text = '".$title."', Start_Date = '".$newDate."', Duration = '".$duration."', Yearly = '".$yearly."' WHERE ID = '".$event_id."'";
    $m_res = $m_dbObj->query( $m_sql, __METHOD__ );
	

	$m_tblCalList = $m_dbObj->tableName( 'mscal_list' );
	
	$m_sql = "DELETE FROM $m_tblCalList WHERE Text_ID = '".$event_id."'";
    $m_res = $m_dbObj->query( $m_sql, __METHOD__ ); 
	
		
	for($i=0;$i<$duration;$i++){
		$addDate = date('Y-m-d', strtotime($newDate. ' + '.$i.' days'));
		$m_sql = "INSERT INTO $m_tblCalList (ID, Date, Text_ID, Day_of_Set, Cal_ID) VALUES ('','".$addDate."','".$event_id."','".($i+1)."','".$cal_id."')";
    	$m_res = $m_dbObj->query( $m_sql, __METHOD__ ); 
	} //for
	

	
	$vars[$newDate2][] = array( 
    			"ID" => $event_id,
    			"Text" => $title,
    			"Duration" => $duration,
    			"Yearly" => $yearly
			);
	
	return json_encode($vars);
}

$wgAjaxExportList[] = 'MsCalRemove';
function MsCalRemove($cal_id,$date,$title,$event_id,$duration){
		
	$newDate2 = date("m-d-Y", strtotime($date));	
	
	$m_dbObj =& wfGetDB( DB_SLAVE );
   	$m_tblCalCont = $m_dbObj->tableName( 'mscal_content' );		
			    
	$m_sql = "DELETE FROM $m_tblCalCont WHERE ID = '".$event_id."'";
    $m_res = $m_dbObj->query( $m_sql, __METHOD__ );
	
	
	$m_tblCalList = $m_dbObj->tableName( 'mscal_list' );
	
	$m_sql = "DELETE FROM $m_tblCalList WHERE Text_ID = '".$event_id."'";
    $m_res = $m_dbObj->query( $m_sql, __METHOD__ ); 
	
	
	$vars[$newDate2][] = array( 
    			"ID" => $event_id,
    			"Text" => $title,
    			"Duration" => $duration,
    			"Yearly" => $yearly
			);
	
	return json_encode($vars);
}


$wgAjaxExportList[] = 'MsCalCheckDB';
function MsCalCheckDB($cal_name){
			
		# Get a database object:
	    $m_dbObj =& wfGetDB( DB_SLAVE );
		$m_tblCal = $m_dbObj->tableName( 'mscal_names' );
	    
		try{
			$m_sql = "SELECT ID, Cal_Name FROM $m_tblCal WHERE Cal_Name = '".$cal_name."'";
			$m_res = $m_dbObj->query( $m_sql, __METHOD__ ); 
			$m_row = $m_dbObj->fetchRow( $m_res );
				
			if($m_row){	
				 $vars['cal_id'] = 	$m_row['ID'];	
			} else {
				$m_sql = "INSERT INTO $m_tblCal (ID, Cal_Name) VALUES ('','".$cal_name."')";
			    $m_dbObj->query( $m_sql, __METHOD__ );   		
				$vars['info'] = "Kalender erfolgreich erstellt.";
				return json_encode($vars);
			}

		}
		catch(Exception $e){
			$m_sql = "CREATE TABLE IF NOT EXISTS $m_tblCal (
		  		ID int(11) NOT NULL auto_increment,
		    	Cal_Name varchar(255) NOT NULL DEFAULT '0',
		    	PRIMARY KEY (ID) );";
		    $m_dbObj->query( $m_sql, __METHOD__ );
			
			$m_sql = "INSERT INTO $m_tblCal (ID, Cal_Name) VALUES ('','".$cal_name."')";
			$m_dbObj->query( $m_sql, __METHOD__ );   		
			$vars['info'] = "Kalender erfolgreich erstellt.";
			$vars['info'] = "Tabelle Cal_Names angelegt.";
		}


		$m_tblCalList = $m_dbObj->tableName( 'mscal_list' );
		try{	
			$m_sql = "SELECT ID FROM $m_tblCalList LIMIT 1";
			$m_dbObj->query( $m_sql, __METHOD__ ); 	
		}	
		catch(Exception $e){
			$m_sql = "CREATE TABLE IF NOT EXISTS $m_tblCalList (
		  	ID int(11) NOT NULL auto_increment,
		    Date DATE NOT NULL,
		    Text_ID int(11) NOT NULL DEFAULT '0',
		    Day_of_Set int(11) NOT NULL DEFAULT '1',
		    Cal_ID int(11) NOT NULL,
		    PRIMARY KEY (ID) );";
		    $m_dbObj->query( $m_sql, __METHOD__ );
			$vars['info'] = "Tabelle Cal_List angelegt.";
		}

		$m_tblCalContent = $m_dbObj->tableName( 'mscal_content' );
		try{
			$m_sql = "SELECT ID FROM $m_tblCalContent LIMIT 1";
			$m_dbObj->query( $m_sql, __METHOD__ ); 		
		}	
		catch(Exception $e){
			$m_sql2 = "CREATE TABLE IF NOT EXISTS $m_tblCalContent (
		  	ID int(11) NOT NULL auto_increment,
		    Text varchar(255) NOT NULL DEFAULT '0',
		    Start_Date DATE NOT NULL,
		    Duration int(11) NOT NULL DEFAULT '0',
		    Yearly int(11) NOT NULL DEFAULT '0',
		    PRIMARY KEY (ID) );";
		    $m_dbObj->query( $m_sql2, __METHOD__ );
			$vars['info'] = "Tabelle Cal_Content angelegt.";
		}
		
		return json_encode($vars);
	
}